//package src;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.regex.Pattern;



public class AssociateProteinsWithUTRSequences {
	//public static final String path = "data_noHub/";
	public static final int motifLength = 8;
	public static String UTRtype; // = 5 or 3;
	public static boolean Randomized; // = true or false;
	public static int motifDivider; //1 or 2 or 3 or 4
	
	private static Hashtable<String,Pair<List<String>,List<String>>> readSeqs(BufferedReader in){
		Hashtable<String,Pair<List<String>,List<String>>> seqs = new Hashtable<String,Pair<List<String>,List<String>>>();
		try{
			String s = in.readLine();
			while(s!=null){
				String[] split = s.split(" ");
				
				String[] subSplit = split[0].split("_");
				String RefSeqID = subSplit[2]+"_"+subSplit[3];
				String info = s;
				s = in.readLine();
				String seq = "";
				
				while(s.charAt(0)!='>'){
					seq = seq+s;
					s = in.readLine();
					if(s == null){
						break;
					}
				}
				if(seqs.containsKey(RefSeqID)){
					 List<String> infosForAnID = seqs.get(RefSeqID).gets();
					 List<String> sequencesForAnID = seqs.get(RefSeqID).getf();
					 if(!sequencesForAnID.contains(seq)){
						 if(!info.contains("hap")){
							 //System.out.println("TWO Different SEQUENCES FOR THE SAME REFSEQ ID");
							 //System.out.println(RefSeqID);
							 seqs.remove(RefSeqID);
							 sequencesForAnID.add(seq);
							 infosForAnID.add(info);
							 Pair<List<String>,List<String>> seqAndInfoForID = new Pair<List<String>,List<String>>(sequencesForAnID,infosForAnID);
							 seqs.put(RefSeqID, seqAndInfoForID);
						 }
					 }
				}
				else{
					if(!info.contains("hap")){
						List<String> sequencesForAnID = new ArrayList<String>();
						List<String> infosForAnID = new ArrayList<String>();
						sequencesForAnID.add(seq);
						infosForAnID.add(info);
						Pair<List<String>,List<String>> seqAndInfoForID = new Pair<List<String>,List<String>>(sequencesForAnID,infosForAnID);
						seqs.put(RefSeqID, seqAndInfoForID);
					}
				}
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		return seqs;
	}

	
	private static Hashtable<String,HashSet<String>> readSynonymFile(BufferedReader in){
		Hashtable<String,HashSet<String>> synTable = new Hashtable<String, HashSet<String>>();
		try{
			String s = in.readLine();
			s = in.readLine();
			while(s!=null){
				String[] split = s.split("\t");
				String symbol = split[2];
				HashSet<String> syns = new HashSet<String>();
				String[] splitSyns = split[4].split("\\|");
				for(int i = 0; i < splitSyns.length; i++){
					syns.add(splitSyns[i]);
				}
				synTable.put(symbol, syns);
				s = in.readLine();
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return synTable;
	}
	
	private static Hashtable<String,HashSet<String>> readSynonymFileForNonOfficialNames(BufferedReader in){
		Hashtable<String,HashSet<String>> synTable = new Hashtable<String, HashSet<String>>();
		HashSet<String> nameAssociatedToMultipleProteins = new HashSet<String>();
		HashSet<String> officialSymbol = new HashSet<String>();
		try{
			String s = in.readLine();
			s = in.readLine();
			while(s!=null){
				String[] split = s.split("\t");
				officialSymbol.add(split[2]);
				HashSet<String> syns = new HashSet<String>();
				syns.add(split[2]);
				String[] splitSyns = split[4].split("\\|");
				for(int i = 0; i < splitSyns.length; i++){
					syns.add(splitSyns[i]);
				}
				
				for(String symbol: syns){
					if(!officialSymbol.contains(symbol)){
						if(synTable.containsKey(symbol)){
							nameAssociatedToMultipleProteins.add(symbol);
						}
						else{
							synTable.put(symbol, syns);
						}
					}
				}
				s = in.readLine();
			}
			
			for(String name: nameAssociatedToMultipleProteins){
				synTable.remove(name);
			}
			System.out.println(nameAssociatedToMultipleProteins.size());
		}catch (Exception e) {
			e.printStackTrace();
		}
		return synTable;
	}
	
	public String run(String connectedInteractionNetworkFile, String CrossReferenceTableFile, String SequenceFile, String folder){
		String outputFile ="";
		
		try{

			
			//File f = null;
			//f = new File(path + "ProteinsInNetWorkWithSeqsHumanHBiogrid"+UTRtype+"'UTR_GenomeBrowser_28Fev2013.txt");
			
			//System.out.println("Loading Synonym Table...");
			//BufferedReader in = new BufferedReader(new FileReader(new File(path + "Homo_sapiens.gene_info23Jan2013")));
			//Hashtable<String,HashSet<String>> synonyms = readSynonymFile(in);
			//in = new BufferedReader(new FileReader(new File(path + "Homo_sapiens.gene_info23Jan2013")));
			//Hashtable<String,HashSet<String>> synonymsNonOfficial = readSynonymFileForNonOfficialNames(in);
			//System.out.println("Synonym Table Loaded...");
				
			// ****************************************************************************************
			
			
			//Changed 11/21/2014
			//BufferedReader in = new BufferedReader(new FileReader(new File(path + "BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_Connected_noHub.txt")));
			BufferedReader in = new BufferedReader(new FileReader(new File(connectedInteractionNetworkFile)));
			
			
			//BufferedReader in = new BufferedReader(new FileReader(new File(path + "BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_Connected.txt")));
			//BufferedReader in = new BufferedReader(new FileReader(new File(path + "BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13.txt"))); // CHANGE TO CONNECTED
			// ****************************************************************************************
			System.out.println("Reading relation file...");
			//List<Interaction> interactions = readHuPIFile(in,synonyms,synonymsNonOfficial );
			List<Interaction> interactions = readBiogridFile(in);	
			
			HashSet<String> proteins = new HashSet<String>();
			for(Interaction r: interactions){
				if(!proteins.contains(r.getBait())){
					proteins.add(r.getBait());
				}
				if(!proteins.contains(r.getPrey())){
					proteins.add(r.getPrey());
				}
			}
			System.out.println("Real Number of proteins: " + proteins.size());
			System.out.println("Should be: 14113 or 14021 for Connected");
			
			System.out.println("Relation file read");
			
			
			System.out.println("Getting the list of all proteins...");
			List<ProteinPlusInfo> genesInNetwork = getAllProteins(interactions);
			System.out.println("List of proteins gotten");
			
			for(ProteinPlusInfo p: genesInNetwork){
				if(p.getName().equals("HIC1")){
					System.out.println("HIC1");
				}
			}
			
			System.out.println("Number of proteins: "+ genesInNetwork.size());
			System.out.println("Should be: 14113 or 14021 for Connected");
			for(ProteinPlusInfo p: genesInNetwork){
				if(p.getName().equals("POLR1C")){
					System.out.println("HELLLLLLLLLLOOOOOOOOO");
				}
			}
				
			//11/21/2014
			//in = new BufferedReader(new FileReader(new File(path + "kgXref23Jan2013")));
			in = new BufferedReader(new FileReader(new File(CrossReferenceTableFile)));
			
			
			Hashtable<String,HashSet<String>> GeneSymbolToRefSeqID = new Hashtable<String, HashSet<String>>();
			String s = in.readLine();
			s = in.readLine();
			while(s!=null){
				String[] split = s.split("\t");
				if(!split[5].equals("")){
					/*if(s.contains("non-coding RNA") || s.contains("pseudogene")){
						System.out.println("WARNING A PSEUDOGENE WAS INCLUDED");
						System.out.println(s);
					}*/
					if(GeneSymbolToRefSeqID.containsKey(split[4])){
						HashSet<String> GBID = GeneSymbolToRefSeqID.get(split[4]);
						GeneSymbolToRefSeqID.remove(split[4]);
						GBID.add(split[5]);
						GeneSymbolToRefSeqID.put(split[4],GBID);
					}
					else{
						HashSet<String> GBID = new HashSet<String>();
						GBID.add(split[5]);
						GeneSymbolToRefSeqID.put(split[4],GBID);
					}
				}
				s = in.readLine();
			}
		
				//System.out.println(GeneSymbolToRefSeqID.get("POLR1C"));
				
			//HERE
			//
			//then match to official ids then match to synonyms
			
			System.out.println("Reading sequences...");
			
			//Changed 11/21/2014
			//in = new BufferedReader(new FileReader(new File(path + "" + args[0]+"UTR_RefSeq_OneRecordPerGene28Feb13.txt")));
			in = new BufferedReader(new FileReader(new File(SequenceFile)));
			
			
			
			Hashtable<String,Pair<List<String>,List<String>>> seqs = readSeqs(in);

			
			System.out.println("Sequences Read");
				
			System.out.println("Associating sequences with proteins...");
			List<ProteinPlusInfo> protsInNetworkWithSeqs = associateSeqs(genesInNetwork,seqs,GeneSymbolToRefSeqID);
			System.out.println("Association done...");
				
			seqs.clear();
			genesInNetwork.clear();	
			GeneSymbolToRefSeqID.clear();
			interactions.clear();
		//		synonyms.clear();
				
			System.out.println("Writing file of proteins with associated sequences...");
			
			//Changed 11/21/2014
			//UTRtype = args[0];
			
			//Changed 11/21/2014
			//BufferedWriter out = new BufferedWriter(new FileWriter(new File(path + "ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_"+UTRtype+"'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13.txt")));
			String[] fileNameSplit = connectedInteractionNetworkFile.split("\\.");
			
			for(int i = 0; i < (fileNameSplit.length-1); i++){
				outputFile = outputFile + fileNameSplit[i];
			}
			outputFile = outputFile+"ProteinAssociatedSequences.txt";
			BufferedWriter out = new BufferedWriter(new FileWriter(new File(outputFile)));
			
			//Comment from 11/21/2014 I don't think that this file is used by any other program. It was only outputted to provide information about the length of sequences.
			BufferedWriter out2 = new BufferedWriter(new FileWriter(new File(folder +"/"+ "28Feb13_UTR_LengthDistribution_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13.txt")));

//			BufferedWriter out = new BufferedWriter(new FileWriter(new File(path + "ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_"+UTRtype+"'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_20Mar13.txt")));
//			BufferedWriter out2 = new BufferedWriter(new FileWriter(new File(path + "Biogrid28Feb13_"+UTRtype+"'UTR_LengthDistribution_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_20Mar13.txt")));
			for(ProteinPlusInfo p: protsInNetworkWithSeqs){
				out.write(p.getName());
				for(int i = 0; i < p.getInfo().size(); i++){
					String info = p.getInfo().get(i);
					out.write("\t" + info);
				}
				for(int i = 0; i < p.getSeq().size(); i++){
					String seq = p.getSeq().get(i);
					out.write("\t" + seq);
					out2.write(seq.length()+"\n");
					out2.flush();
				}
				out.write("\n");
				out.flush();
			}
			out.close();
			out2.close();
				
			System.out.println(protsInNetworkWithSeqs.size());
			//}
			
				
				
				

						
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		return outputFile;
	}
	
	public static Hashtable<String,String> readFastaFiles(BufferedReader in){
		Hashtable<String,String> hash = new Hashtable<String, String>();
		try{
			String s = in.readLine();
			String proteinName = "PLACEHOLDER";
			String seq = "PLACEHOLDER";
			while(s != null){
				
				if(s.charAt(0) == '>'){
					if(!proteinName.equals("PLACEHOLDER")){
						hash.put(proteinName, seq);
					}
					proteinName = "";
					seq = "";
					String[] split = s.split("_");
					proteinName = split[2].split(" ")[0];
				}
				else{
					seq = seq+s;
				}
				s = in.readLine();
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		/*		>sacCer2_sgdGene_YAL012W range=chrI:129802-130801 5'pad=0 3'pad=0 strand=+ repeatMasking=none
		cagaggatgactgcgctgaaggaaatcaccgacatcgagtacaagttcgc
		gcaattgcgccaaaaactatatgacaatcaattggtgcggttgcaaacgg
		agctgcagatgtgtctggaagggtcacacccggaattgcaggtctactac
		tcgaagattgccgcgatccgtgactacaagctacaccgagcgtaccagcg
		acagaagtacgagctttcatgcatcaacacagaaacaatcgctaccagga
		cattcattcaccaggacttccacaagaaggtcaccgacctgcgagccagg
		ctgctgaacagaaccacgcagacctggtacgatatcaacaaggagcgccg
		cgatatggatatagtcatcccagatgtcaattaccacgtccccatcaaac
		ttgataacaagacgctgagctgtatcacgggctacgccagcgcagcacag
		ctgtgctatcccggcgagcccgtggcagaggacctcgcttgcgaaagcat
		cgagtaccgctacagagccaacccggtggacaaactcgaagtcattgtgg
		accgaatgaggctcaataacgagattagcgacctcgaaggcctgcgcaaa
		tatttccactccttcccgggtgctcctgagttgaacccgcttagagactc
		cgaaatcaacgacgacttccaccagtgggcccagtgtgaccgccacactg
		gaccccataccacttctttttgttattcttaaatatgttgtaacgctatg
		taattccacccttcattactaataattagccattcacgtgatctcagcca
		gttgtggcgccacacttttttttccataaaaatcctcgaggaaaagaaaa
		gaaaaaaatatttcagttatttaaagcataagatgccaggtagatggaac
		ttgtgccgtgccagattgaattttgaaagtacaattgaggcctatacaca
		tagacatttgcaccttatacatatacacacaagacaaaaccaaaaaaaat
		>sacCer2_sgdGene_YAL069W range=chrI:1-334 5'pad=0 3'pad=0 strand=+ repeatMasking=none*/

		
		return hash;
	}
	
	public static String removeSpaces(String s) {
		  StringTokenizer st = new StringTokenizer(s," ",false);
		  String t="";
		  while (st.hasMoreElements()) t += st.nextElement();
		  return t;
	}
	
	private static List<ProteinPlusInfo> associateSeqs(List<ProteinPlusInfo> genesInNetwork, Hashtable<String,Pair<List<String>,List<String>>> seqs, Hashtable<String,HashSet<String>> SymbolToGenomeBrowserID){
		List<ProteinPlusInfo> pWithSeqs = new ArrayList<ProteinPlusInfo>();
		for(ProteinPlusInfo p: genesInNetwork){
			boolean foundIDMapping = false;
			if(p.getName().equals("POLR1C")){ //TO CHECK
				System.out.println(p.getName());
			}
			if(SymbolToGenomeBrowserID.containsKey(p.getName())){
				
				HashSet<String> GenomeBrowserIDs = SymbolToGenomeBrowserID.get(p.getName());
				if(p.getName().equals("POLR1C")){
					System.out.println(p.getName());
					System.out.println(GenomeBrowserIDs);
				}
				for(String GenomeBrowserID: GenomeBrowserIDs){
					if(seqs.containsKey(GenomeBrowserID)){
						List<String> sequences = seqs.get(GenomeBrowserID).first;
						List<String> infos = seqs.get(GenomeBrowserID).second;
						for(int i = 0; i < sequences.size(); i++){
							String seq = sequences.get(i);
							String info = infos.get(i);
							if(!p.getSeq().contains(seq)){
								p.addSeq(seq);
								p.addInfo(info);
							}
							foundIDMapping = true;
						}
					}
				}
			}
			else{
				for(String syn: p.getSyns()){
					boolean found = false;
					if(SymbolToGenomeBrowserID.containsKey(syn)){
						for(ProteinPlusInfo p2: genesInNetwork){
							for(String otherSyn: p2.getSyns()){
								if(otherSyn.equalsIgnoreCase(syn) && !p.getName().equalsIgnoreCase(p2.getName())){
									found = true;
									System.out.println("TOCHECK" + syn);
									break;
								}
							}
							if(found){
								break;
							}
						}
						if(!found){
							HashSet<String> GenomeBrowserIDs = SymbolToGenomeBrowserID.get(syn);
							
							for(String GenomeBrowserID: GenomeBrowserIDs){
								if(seqs.containsKey(GenomeBrowserID)){
									System.out.println("GOOD HIT TO CHECK" + syn);
									List<String> sequences = seqs.get(GenomeBrowserID).first;
									List<String> infos = seqs.get(GenomeBrowserID).second;
									for(int i = 0; i < sequences.size(); i++){
										String seq = sequences.get(i);
										String info = infos.get(i);
										if(!p.getSeq().contains(seq)){
											p.addSeq(seq);
											p.addInfo(info);
										}
										foundIDMapping = true;
									}
								}
							}
							break;
						}
					}
				}
			}
			if(foundIDMapping){
				pWithSeqs.add(p);
			}
			
		}
		return pWithSeqs;
	}
	
	private static List<ProteinPlusInfo> getAllProteins(List<Interaction> ints){
		List<ProteinPlusInfo> prots = new ArrayList<ProteinPlusInfo>();
		for(Interaction i: ints){
			boolean baitFound = false;
			boolean preyFound = false;
			for(ProteinPlusInfo p: prots){
				if(p.getName().equalsIgnoreCase(i.getBait())){
					baitFound = true;
				}
				if(baitFound){
					break;
				}
			}
			if(!baitFound){
				ProteinPlusInfo p = new ProteinPlusInfo(i.getBait(),i.getBaitSyn());
				prots.add(p);
			}
			for(ProteinPlusInfo p: prots){
				if(p.getName().equalsIgnoreCase(i.getPrey())){
					preyFound = true;
				}
				if(preyFound){
					break;
				}
			}
			if(!preyFound){
				ProteinPlusInfo p = new ProteinPlusInfo(i.getPrey(),i.getPreySyn());
				prots.add(p);
			}
		}
		return prots;
	}
	
	private static List<Interaction> readBiogridFile(BufferedReader in){
		
		List<Interaction> ints = new ArrayList<Interaction>();
		//HashSet<String> notOfficialSymbol = new HashSet<String>();
		try{
			String s = in.readLine();
			s = in.readLine();
			while(s!=null){
				String[] split = s.split("\t");
				if(split[15].equals("9606") && split[16].equals("9606")){
					HashSet<String> baitSyn = new HashSet<String>();
					baitSyn.add(split[7]);
					String[] splitSyns = split[9].split("\\|");
					for(int i = 0; i < splitSyns.length; i++){
						baitSyn.add(splitSyns[i]);
					}
					HashSet<String> preySyn = new HashSet<String>();
					preySyn.add(split[8]);
					splitSyns = split[10].split("\\|");
					for(int i = 0; i < splitSyns.length; i++){
						preySyn.add(splitSyns[i]);
					}
					
					Interaction i =null;
					i = new Interaction(split[7],split[8],baitSyn,preySyn,"hupi","hupi","hupi");
					ints.add(i);
					
				}
				s = in.readLine();
			}
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		return ints;
	}

	
	private static List<Interaction> readHuPIFile(BufferedReader in, Hashtable<String,HashSet<String>> synonyms, Hashtable<String,HashSet<String>> synonymsNonOfficial){
		List<Interaction> ints = new ArrayList<Interaction>();
		HashSet<String> notOfficialSymbol = new HashSet<String>();
		try{
			String s = in.readLine();
			while(s!=null){
				String[] split = s.split("\t");
				HashSet<String> baitSyn = new HashSet<String>();
				baitSyn.add(split[0]);
				if(synonyms.get(split[0]) != null){
					baitSyn.addAll(synonyms.get(split[0]));
				}
				else{
					if(synonymsNonOfficial.get(split[0]) !=null ){
						baitSyn.addAll(synonymsNonOfficial.get(split[0]));
					}
					else{
						if(!notOfficialSymbol.contains(split[0])){
							notOfficialSymbol.add(split[0]);
						}
					}
				}
				HashSet<String> preySyn = new HashSet<String>();
				preySyn.add(split[1]);
				if(synonyms.get(split[1]) != null){
					preySyn.addAll(synonyms.get(split[1]));
				}
				else{
					if(synonymsNonOfficial.get(split[1]) !=null ){
						preySyn.addAll(synonymsNonOfficial.get(split[1]));
					}
					else{
						if(!notOfficialSymbol.contains(split[1])){
							notOfficialSymbol.add(split[1]);
						}
					}
				}
				Interaction i =null;
				if(split[2].equalsIgnoreCase("HUPI")){
					i = new Interaction(split[0],split[1],baitSyn,preySyn,"hupi","hupi","hupi");
				}
				else{
					i = new Interaction(split[0],split[1],baitSyn,preySyn,"hupi","hupi","biogrid");
				}
				ints.add(i);
				s = in.readLine();
			}
			System.out.println(notOfficialSymbol.size());
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		return ints;
		
	}

	
	
}
