
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class BuildBioGRIDDistanceMatrix {
	private static List<Protein> baits;
	static double Dist[][];
	private static double largestWeight; 

	public BuildBioGRIDDistanceMatrix(){
		
	}
	
	//	static double RightDist[][];
	public String run(String interactionFile){
		String DistanceMatrixFile = "";
		try{
			String dataSet = "hupi";
			System.out.println("Weighted or Unweighted graph (w/u)?");
			//InputStreamReader input = new InputStreamReader(System.in);
		    //BufferedReader reader = new BufferedReader(input);
	        //String weightInfo = reader.readLine();
			String weightInfo = "u";
	        //Jeronimo DataSet
	        //File relationsFile = new File("src/go/HuPIRelations14Nov2010.txt");
	        //File relationsFile = new File("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridMay1st.txt");
	        
	        //File relationsFile = new File("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1st.txt");
	        
	        //File relationsFile = new File("src/go/BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_SimpleFormat.txt");
	        //File relationsFile = new File("src/go/BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormat.txt");
			//File relationsFile = new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.90.tab2_20July2012_SimpleFormat.txt");
			
			//File relationsFile = new File("HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogrid_11July2012.txt");
			
			File relationsFile = new File(interactionFile);
			//Was used 11/21/2014
			//File relationsFile = new File("data_nohub/BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_Connected_noHub.txt");
			
	        
	        //XAB1 Paper DataSet
	        //File relationsFile = new File("src/go/XAB1PaperRelsRatio2.txt");
			FileReader fRRelation = new FileReader(relationsFile);
			BufferedReader relationsReader = new BufferedReader(fRRelation);
			
			largestWeight = 500.0;
			
			List<Relation> relations = createRelationList(relationsReader,dataSet);
			baits = createBaitList(relations);
			
			HashSet<String> proteins = new HashSet<String>();
			for(Relation r: relations){
				if(!proteins.contains(r.getBait().getName().toUpperCase())){
					proteins.add(r.getBait().getName().toUpperCase());
				}
				if(!proteins.contains(r.getTarget().getName().toUpperCase())){
					proteins.add(r.getTarget().getName().toUpperCase());
				}
			}
			System.out.println("Real Number of proteins: " + proteins.size());
			
			
			System.out.println("Creating Adjacency List");
			List<Pair<Protein,List<Pair<Double,Protein>>>> proteinList = createAdjacencyList(relations,baits);
			System.out.println("Number of proteins: " + proteinList.size());
			System.out.println("Largest Weight in the network: "+ largestWeight);
			boolean weighted = false;
			
			if(weightInfo.equalsIgnoreCase("w")){
				weighted = false;
			}
			System.out.println("Computing Distance Matrix");
			DistanceMatrixFile = computeDistanceMatrix(proteinList,weighted,interactionFile);
			
			
		}catch(Exception e){
			e.printStackTrace();
		}
		return DistanceMatrixFile;
	}
	
	private static boolean isConnected(int i, String proteinName,List<Pair<Protein,List<Pair<Double,Protein>>>> pList){
		for(Pair<Double,Protein> p: pList.get(i).gets()){
			if (p.gets().getName().equalsIgnoreCase(proteinName)){
				return true;
			}
		}
		return false;
	}
	
	private static double WeightedConnection(int i, String proteinName, List<Pair<Protein,List<Pair<Double,Protein>>>> pList){
		for(Pair<Double,Protein> p: pList.get(i).gets()){
			if (p.gets().getName().equalsIgnoreCase(proteinName)){
				if (p.getf() < largestWeight){
					return p.getf();
				}
				else{
					return largestWeight;
				}
			}
		}
		return Double.MAX_VALUE;
	}
	
	private static String computeDistanceMatrix(List<Pair<Protein,List<Pair<Double,Protein>>>> pList, boolean weighted, String interactionFile){
		String outputFile = "";
		Dist = new double[pList.size()][pList.size()];
		//double Dist[][] = new double[pList.size()][pList.size()];
		for(int i = 0; i < pList.size(); i++){
			for (int j = 0; j < pList.size(); j++){
				if(i == j){
					Dist[i][j] = 0.0;
					continue;
				}
				if(!weighted){
					if (isConnected(i,pList.get(j).getf().getName(),pList)){
						
						Dist[i][j] = 1.0;
					}
					else{
						Dist[i][j] = Double.MAX_VALUE;
					}
				}
				else{
					if(WeightedConnection(i,pList.get(j).getf().getName(),pList) < Double.MAX_VALUE){
						Dist[i][j] = 1+Math.log10(((largestWeight+1) - WeightedConnection(i,pList.get(j).getf().getName(),pList)));
					}
					else{
						Dist[i][j] = Double.MAX_VALUE;
					}
				}		
			}
		}
		for (int k = 0; k < Dist.length; k++){
			System.out.println("k = " + k);
			for (int i = 0; i < Dist.length; i++){
				for (int j = 0; j < Dist.length; j++){
					if (Dist[i][j] > (Dist[i][k] + Dist[k][j])){
						Dist[i][j] = Dist[i][k] + Dist[k][j];
					}
				}
			}	
		}
		
		try{
	        //Jeronimo DataSet
			//BufferedWriter o = new BufferedWriter(new FileWriter("src/go/HuPIRelations14Nov2010DistanceMatrix.txt"));
			//BufferedWriter o = new BufferedWriter(new FileWriter("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridMay1stDistanceMatrixConnected_8Mai2010.txt"));
			//BufferedWriter o = new BufferedWriter(new FileWriter("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridMay1stDistanceMatrixConnected_8Mai2010.txt"));
			//BufferedWriter o = new BufferedWriter(new FileWriter("src/go/BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_DistanceMatrix.txt"));
			
			
			//BufferedWriter o = new BufferedWriter(new FileWriter("BIOGRID_Yeast_3.1.90.tab2_20July2012_DistanceMatrix.txt"));
			
			
			
			//Was used 11/21/2014
			//BufferedWriter o = new BufferedWriter(new FileWriter("data_nohub/BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_DistanceMatrix_Connected_noHub.txt"));
			String[] fileNameSplit = interactionFile.split("\\.");
			
			for(int i = 0; i < (fileNameSplit.length-1); i++){
				outputFile = outputFile + fileNameSplit[i];
			}
			outputFile = outputFile+"_DistanceMatrix.txt";
			BufferedWriter o = new BufferedWriter(new FileWriter(outputFile));
			
			//BufferedWriter o = new BufferedWriter(new FileWriter("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridMay1stDistanceMatrix_8Mai2010.txt"));
	        //XAB1 Paper DataSet
			//BufferedWriter o = new BufferedWriter(new FileWriter("src/go/XAB1PaperRelsRatio2WeightedDistMatrix.txt"));
			for (int i = 0; i < Dist.length; i++){
				for (int j = 0; j < Dist.length; j++){
					o.write(Dist[i][j] + "\t");
				}
				o.write("\n");
				o.flush();
			}
			for (int i = 0; i < pList.size(); i++){
				o.write(pList.get(i).getf().getName()+ "\t");
			}
			o.write("\n");
			o.close();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		return outputFile;
	}
	
	private static List<Protein> createBaitList(List<Relation> relations){
		List<Protein> baits = new ArrayList<Protein>();
		for(Relation relation: relations){
			boolean found = false;
			for(Protein p: baits){
				if(relation.getBait().getName().equalsIgnoreCase(p.getName())){
					found = true;
				}
			}
			if(found == false){
				baits.add(relation.getBait());
			}
		}
		return baits;
	}
	
	private static List<Relation> createRelationList(BufferedReader relationsReader,String dataSet){
		List<Relation> relations = new ArrayList<Relation>();
		try{
			String relationLine = relationsReader.readLine();
			//relationLine = relationsReader.readLine();
			//BufferedWriter w = new BufferedWriter(new FileWriter("go/KroganTable7G0.273ONLY.txt"));
			double sum = 0.0;
			HashSet<String> leftOutHubs = new HashSet<String>();
			leftOutHubs.add("CUL3");
			leftOutHubs.add("SUMO2");
			leftOutHubs.add("ELAVL1");
			leftOutHubs.add("UBC");
			while (relationLine != null){
				String[] relationTokens = relationLine.split("\t");
				
				if(!leftOutHubs.contains(relationTokens[7])){
					if(!leftOutHubs.contains(relationTokens[8])){
						
							
						
							
						//Set<String> color = color(colorMap,relationTokens[0]);
						Set<String> blank = new HashSet<String>();
						Protein bait = new Protein(true,relationTokens[7],blank);
						//color = color(colorMap,relationTokens[1]);
						Protein target = null;
						Double mascot = -1.0;
						if(relationTokens[15].equals("9606") && relationTokens[16].equals("9606")){
							if(dataSet.equalsIgnoreCase("hupi")){
								target = new Protein(false,relationTokens[8],blank);
						//		mascot = Double.parseDouble(relationTokens[2]);
							}
							else if(dataSet.equalsIgnoreCase("Collins")){
								target = new Protein(false,relationTokens[2],blank);
							}
							//Double mascot = Double.parseDouble(relationTokens[]);
				 
						
							
							//Double iR = Double.parseDouble(relationTokens[2]);
							Double iR = -1.0;
							Relation relation = new Relation(bait,target,mascot,iR);
							relations.add(relation);
						}
					}
				}

				relationLine = relationsReader.readLine();
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return relations;
		
	}
	private static boolean isBait(String pName, List<Protein> baits){
		boolean isBait = false;
		for(Protein bait: baits){
			if(bait.getName().equalsIgnoreCase(pName)){
				isBait = true;
				break;
			}
		}
		return isBait;
	}
	
	private static List<Pair<Protein,List<Pair<Double,Protein>>>> createAdjacencyList(List<Relation> relations, List<Protein> baits){
		List<Pair<Protein,List<Pair<Double,Protein>>>> proteinList = new ArrayList<Pair<Protein,List<Pair<Double,Protein>>>>();
		for (Relation r: relations){
			String baitName = r.getBait().getName();
			String targetName = r.getTarget().getName();
			boolean foundBait = false;
			boolean foundTarget = false;
			for(Pair<Protein,List<Pair<Double,Protein>>> proteinNode: proteinList){
				if (proteinNode.getf().getName().equals(baitName)){
					boolean found = false;
					for (Pair<Double,Protein> p: proteinNode.gets()){
						if(p.gets().getName().equalsIgnoreCase(targetName)){
							found = true;
						}
					}
					if (found == false){
						boolean isBait = isBait(targetName, baits);
						proteinNode.gets().add(new Pair<Double,Protein>(r.getMascot(), new Protein(isBait,targetName,r.getTarget().getColor())));
					}
					foundBait = true;
				}
			}
			if (foundBait == false){
				boolean isBait = isBait(baitName, baits);
				Protein bait = new Protein(isBait,baitName,r.getBait().getColor());
				isBait = isBait(targetName, baits);
				Pair<Double,Protein> target = new Pair<Double,Protein>(r.getMascot() , new Protein(isBait,targetName,r.getTarget().getColor()));
				List<Pair<Double,Protein>> links = new ArrayList<Pair<Double,Protein>>();
				links.add(target);
				proteinList.add(new Pair<Protein,List<Pair<Double,Protein>>>(bait, links));
			}
			for(Pair<Protein,List<Pair<Double,Protein>>> proteinNode: proteinList){
				if (proteinNode.getf().getName().equals(targetName)){
					boolean found = false;
					for (Pair<Double,Protein> p: proteinNode.gets()){
						if(p.gets().getName().equalsIgnoreCase(baitName)){
							found = true;
						}
					}
					if (found == false){
						boolean isBait = isBait(baitName, baits);
						proteinNode.gets().add(new Pair<Double,Protein>(r.getMascot(),new Protein(isBait,baitName,r.getBait().getColor())));
					}
					foundTarget = true;
				}
			}
			if(foundTarget == false){
				boolean isBait = isBait(baitName, baits);
				Pair<Double,Protein> bait = new Pair<Double,Protein>(r.getMascot(),new Protein(isBait,baitName,r.getBait().getColor()));
				isBait = isBait(targetName, baits);
				Protein target = new Protein(isBait,targetName,r.getTarget().getColor());
				List<Pair<Double,Protein>> links = new ArrayList<Pair<Double,Protein>>();
				links.add(bait);
				proteinList.add(new Pair<Protein,List<Pair<Double,Protein>>>(target, links));
			}
		}

		return proteinList;
	}
}
