
import java.util.List;
/**
 * Parses a file produced by GO-Stats and calculates some
 * information theory measures on it.
 * 
 * How to create a file for this program:
 * 		1-) Go to  http://gostat.wehi.edu.au/cgi-bin/goStat.pl
 * 		2-) Upload the genes you are interested in
 * 		3-) Select parameters:
 * 				Maximum number of GOs/groups to display:	10000
 * 				Display Format: 							TEXT, Stats and GO Annotation
 * 				Correct for multiple testing:				NONE
 * 		4-) Submit the form and save the results as a text file
 * 
 * Notes:
 * 	- Executing the query with the files singleExon-Flush-CRUNCS_hg18_GeneNames 
 *    and singleExon-Flush-CRUNCS_hg18_RefSeqs does NOT produce the same result
 *
 * @author Pablo Cingolani
 *
 */
//Changed 11/21/2014
//public class MainForDNAUTRMotifsTop1PercentGetSmallerCores {
public class DNAUTRMotifsTop1PercentGetSmallerCoresFinder{

	public static boolean debug = false;
	public static String GOTERMS_ROOT = "GO:0003674";
	public static int maxNumOfSymbolsPerTerm = 500;
	public static int minNumOfSymbolsPerTerm = 5;
	public static String PATH = "data/";
	public static boolean selectFromGOTermsAll = true; // Select terms from goTermsAll or from goTerms (when randomly picking terms)
	public static boolean selectNonLeaves = false; // Just select terms that are non-leaves?
	public static boolean verbose = false;

	//-------------------------------------------------------------------------
	// Static Methods
	//-------------------------------------------------------------------------


	

	/**
	 *-------------------------------------------------------------------------
	 * Main
	 *-------------------------------------------------------------------------
	 */
	
	//This is how to run the software 11/21/2014
	//java MainForDNAUTRMotifsTop1PercentGetSmallerCores BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_Connected_noHub.txt BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_DistanceMatrix_Connected_noHub.txt false 8 5 5 1501 false false > NoHub8_5_106Sim_5_1501_1Percent_SmallerCoresComplete.txt &
	
	// HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogrid_11July2012_Connected.txt HuPI_FDR0.1_14Nov2010_CompleteBIOGRID_Human_3.1.90.tab2_11July2012_Connected_DistanceMatrix.txt true 6 3 2 100
	
	//Changed on 11/21/2014
	//public static void main(String[] args) {
	public Pair<String,String> run(String interactionConnectedFile, String distanceMatrixConnectedFile, boolean doSimulations, int MotifSize, int UTRType, int startOfClusterSizeQUESTIONMARK, int endOfClusterSizeQUESTIONMARK, String sampleBiasFile,String MotifAnnotationFile, boolean randomized, boolean completelyRand, String folder) {
	
		
		PATH = "src/go/";
		ANNETADistDNAMotifsUTR_20July2012_V4GOODVersion_BiasedSampling_Top1Percent_GetSmallerCores ann = new ANNETADistDNAMotifsUTR_20July2012_V4GOODVersion_BiasedSampling_Top1Percent_GetSmallerCores();
		Pair<String,String> outputFileAndCoreFile =null;
		try{
			//Changed on 11/21/2014
			//ann.findGroup(args);
			outputFileAndCoreFile = ann.findGroup(interactionConnectedFile, distanceMatrixConnectedFile, doSimulations, MotifSize, UTRType, startOfClusterSizeQUESTIONMARK, endOfClusterSizeQUESTIONMARK, sampleBiasFile, MotifAnnotationFile, randomized, completelyRand, folder);
			
		
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
		System.out.println("End: GOInfo");
		return outputFileAndCoreFile;
	}
}
