
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class FindLargestConnectedComponentBioGrid {
	
	public FindLargestConnectedComponentBioGrid(){
		
	}
	
	public String run(String distanceMatrixFile, String oldInteractionFile){
		String newInteractionFile = "";
		try{
			//BufferedReader inMatrix = new BufferedReader(new FileReader(new File("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridMay1stDistanceMatrix_8Mai2010.txt")));
			//BufferedReader inMatrix = new BufferedReader(new FileReader(new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_DistanceMatrix.txt")));
			
			//Changed on 11/21/2014
			//BufferedReader inMatrix = new BufferedReader(new FileReader(new File("data_nohub/BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_noHub")));
			BufferedReader inMatrix = new BufferedReader(new FileReader(new File(distanceMatrixFile)));
			
			String s = inMatrix.readLine();
			List<Integer> proteinsToKeep = new ArrayList<Integer>();
			double lineNumber = 0.0;
			while(s != null){
				lineNumber++;
				s = inMatrix.readLine();
			}
			
			
			int lineCounter = 0;
			inMatrix = new BufferedReader(new FileReader(new File(distanceMatrixFile)));
			s = inMatrix.readLine();
			while(s != null){
				String[] split = s.split("\t");
				
				if (split[0].equalsIgnoreCase("MAP2K4")){
				//if (split[0].equalsIgnoreCase("CDK7")){
				//if (split[0].equalsIgnoreCase("YKR002W")){
					break;
				}
				int infCounter = 0;
				for(int i = 0; i < split.length; i++){
					if(Double.parseDouble(split[i]) > 100000000){
						infCounter++;
					}
				}
				if(infCounter < (lineNumber/2.0)){ 
					proteinsToKeep.add(lineCounter);
				}
				lineCounter++;
				s = inMatrix.readLine();
			}
			
			String[] split = s.split("\t");
			
			List<String> genes = new ArrayList<String>();
			
			for(int i = 0; i < split.length; i++){
				if(proteinsToKeep.contains(i)){
					genes.add(split[i]);
				}
			}
			
			
			//Changed on 11/21/2014
			//BufferedReader inRels = new BufferedReader(new FileReader(new File("data_nohub/BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13.txt")));
			//BufferedWriter outRels = new BufferedWriter(new FileWriter(new File("data_nohub/BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_Connected_noHub.txt")));
			BufferedReader inRels = new BufferedReader(new FileReader(new File(oldInteractionFile)));
			
			String[] fileNameSplit = oldInteractionFile.split("\\.");
			
			for(int i = 0; i < (fileNameSplit.length-1); i++){
				newInteractionFile = newInteractionFile + fileNameSplit[i];
			}
			
			newInteractionFile = newInteractionFile+"_Connected.txt";
			BufferedWriter outRels = new BufferedWriter(new FileWriter(new File(newInteractionFile)));
			
			//BufferedReader inRels = new BufferedReader(new FileReader(new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_SimpleFormat.txt")));
			//BufferedWriter outRels = new BufferedWriter(new FileWriter(new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormat.txt")));

			//BufferedReader inRels = new BufferedReader(new FileReader(new File("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridMay1st.txt")));
			//BufferedWriter outRels = new BufferedWriter(new FileWriter(new File("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1st.txt")));
			
			s = inRels.readLine();
			while(s != null){
				String[] rel = s.split("\t");
				boolean foundBait = false;
				boolean foundPrey = false;
				for(String g: genes){
					if(g.equalsIgnoreCase(rel[7])){
						foundBait = true;
					}
					if(g.equalsIgnoreCase(rel[8])){
						foundPrey = true;
					}
					if(foundBait && foundPrey){
						outRels.write(s+"\n");
						outRels.flush();
						break;
					}
				}
			
				s = inRels.readLine();
			}
			outRels.close();
			
			//YKR002W
		}catch (Exception e) {
			e.printStackTrace();
		}
		return newInteractionFile;
	}
}
